=begin
###
Copyright 2015 TIG (c)

All rights reserved.

This software is provided "as is" and without any express or implied 
warranties, including, without limitation, the implied warranties of 
merchantability and fitness for a particular purpose.

File goes in Plugins folder

Usage:

In Ruby Console type [or copy/paste]:  TIG::TextureBaker.new()

All Textures in the Model are assembled into a 'ComboTexture' Material.
Which contains a 'ComboTexture.png' image which you can export.

Version:
1.0 20150225 First issue.
=end
require('sketchup.rb')
module TIG
module TextureBaker
	def self.new()
		model=Sketchup.active_model
		styles=model.styles
		ostyle=styles.selected_style
		mats=model.materials
		ents=model.entities
		view=model.active_view
		cam=view.camera
		eye=cam.eye
		tar=cam.target
		up=cam.up
		per=cam.perspective?
		###
		model.start_operation(self.to_s)
		tdir=File.join(ENV["HOME"], "BakedTextures#{(rand*1000000).to_i}")
		begin
			Dir.mkdir(tdir)
		rescue
		end
		textn=".png"
		tw=Sketchup.create_texture_writer
		Dir.entries(tdir).each{|f|
			next if f=="." || f==".."
			File.delete(File.join(tdir, f))
		}
		ents.clear!
		temp_group=model.active_entities.add_group()
		imgs=[]
		pt=ORIGIN.clone
		wi=0
		hi=0
		msg="#{self.to_s}: Processing Textures"
		tmats=mats.select{|mat| mat.texture }
		tmats.each{|mat|
			msg<<". "
			Sketchup.status_text=msg
			w=mat.texture.width
			h=mat.texture.height
			temp_group.material=mat
			tname = mat.name+textn
			tpath=File.join(tdir, tname)
			tw.load(temp_group)
			tw.write(temp_group, tpath)
			begin
				imgs << ents.add_image(tpath, pt, w)
				pt.x=w+pt.x
				wi+=w
				hi=h if h>hi
			rescue
			end
		}
		###
		temp_group.erase! if temp_group.valid?
		###
		camm=Sketchup::Camera.new([0,0,1000], [0,0,0], [0,1,0], false)
		view.camera=camm
		view.zoom_extents
		### temp.style in binary
		txt="PK\x03\x04\x14\x00\x00\x00\b\x00bpyF\xB6bu{d\x02\x00\x00\xF4\x0E\x00\x00\f\x00\x00\x00document.xml\xA5W]o\x9B0\x14\xFD+\xC8\x0F}\x03\xDB|\x19hH5\xAD\xDDS\xABM\xEA&\xED\x15\x11\x8F\xA0\x81\x89\xB0\xD3\xA4\xFF~\x06\x9ALZ\xED\xE9R\xBF%\x8E\xCE9\xBE\xBE\xE7\xD87\x9B\xBBs\xDFy/|\x94\xED JD\x03\x82<.\xEAa\xD7\x8A\xA6D?\xBE\x7F\xF13\xE4IU\x89]\xD5\r\x82\x97H\f\xC8\xBB\xDBn\xA4z\xED\xF8\xFDP\x1F{.\x94\xA79\x84,\xD1^\xA9C\x81\xB1\xFC\xCDU\xBD?\x1E\x82f\x18\x9A\x8E\a\xF5\xD0cY\xEFy_\xC9\xEBoX+\xE1\x99\x04-\xE8B\x7Fqd\x18A\xF8\t6\xF2_|\xD4ery\xC1\x9Ee{E\x9FN\xA7\xE0\x14\x05\xC3\xD8\xE0\x90\x10\x8A\x7F>=>\xCF`\xBF\x15\xD3Q\xD4\x93\xA2l\x8B\x85\xF1q\xA8+5\x1F\xDE\x876\xEF}\b\x15\x9C\xE5\x0E\xCD](\x16\x96\xA5\n\x05>\x01\xF5z\x98\x8A\x17U\xAF{\xAAx\x7F@\xDE\x8E\xCB\xBADo\xAC\xAD^\xF3\xDA\x9Dv\x04!D\xAF\xA9\xE2\xA5\x1A\xDBJ\xF7zB\x96(F[\xB2\xC1\xD7\xD5\xED\x06_P\xEF\xF1\xD4\x11\x1F\x9A\xF1\x14\x8A\x8F\rx\xBAB?1\xEB\xC7P|\xEA\xA8\xCF\xCC\xFA!\x14\x9F9\xEA\xE7n\xE7OM\xFEY\xA1O-\xFEI\xA1x\x93\x7F\xD6\xE8\x9B\xFC\xA3\xD7|\x9A2\xC6B\n\xDE\x87\xC9G\xE0}\x84\xD6\x1C\xC1|\x10Zs\xE4\xC7I\x9E\x93\fV\x86\xA6\x89,4QHs0\x89S&Cs&)\xD4\x93\xA19\x93k\xCE\xD2\x94\xC95\xFA\xA6LjN\x12$ \x86\xD8z+\xFB\xB0-\xC4V;\xF9\x94\xA6\x04L\xE2\x94\xAD\xD8n&\x9A3\x1AR\xF06\x9C\xEC\x14[\xAF\xF8\bL\xE0t\xC7'\xE6n\x82\xFD\x94\x98\x9BI\xA3\xCBt#\xC8\xFA\xE9\xE4\xD4w\xADT\x9AV\x90b\xF9\xEC\xD5\xC3Q\xA8y_\xD3\xA2\xACG\xCEE\xDBW\r\x97\xFF.\xBC\r\x167\x9D\xBA}\xFAz\xFF\xF0\xE8=\x7F\xFB\xF4\xF9\xE1\xA6Q\xB7\xC8\xC3\xBA\x90wp|U\xD9\x82Jf\xFF\t@\xCC\x92<\xCD`G\xC7\xEC9`y\xC8H\f\xA6\xB1\xDD\xAEY\x92%\xD0G\x82\xD9\x03\xC1\x12\x92E,\x83\xD2\xD8\xDE\xAC\x88\x84i\xCCr(\x8D%\x17\xEB\x9E>\xE68\x820\xC7\x11\x82\x99G\x885x\xCB5\a5\a\xB5t\x15\xACoi'l\x04\xCD\xAC\xD7\vL?3g\x84A\xEB\xCF\x1C\x9F\x89\xCC\x9C\x8A\xF9\xB9\xB4\x06\x02_\xFF\e-\x9F\xFF\xFE[\xDD\xFE\x01PK\x03\x04\x14\x00\x00\x00\b\x00bpyFj\xF8\xE8\xE7w\x01\x00\x00\xAF\x03\x00\x00\x16\x00\x00\x00documentProperties.xml\xADS]k\xC3 \x14\xFD+\xC1\xF7D\xD3\x8F1B\x93\xC2\x1E\xF6\xD4\xC2\xA0\x1D\x8C\xBD\x84Lo\x13i\xA2Am\xD3\xFE\xFBil\x13\xDA\xEDa\x8C\xBEy<\xC7s\xCF\xBD\xEAbyj\xEA\xE0\bJs)R\x14G\x04\x05 \xA8d\\\x94)z\xDF\xBE\x86\xCF(\xD0\xA6\x10\xAC\xA8\xA5\x80\x14\t\x89\x82e\xB6`\x92\x1E\x1A\x10\xE6M\xC9\x16\x94\xE1\xA0\x03k$t\x8A*c\xDA\x04c\xBD\aC\xABC\e\x95R\x965DT6X\xD3\n\x9ABc[\x05_\r\xDA\xC1\x00y\x87\x84\xB5\x0F09i>\xB8t]\x17u\xD3H\xAA\x12O\b\x89\xF1\xC7z\xB5\xE9MB.\\k\x14\xC6\xD2\xB96\xE7\x1A\xFE\x14\xE0\xCA\xF5I\xFAc\xF95O~\x13H\xF3\xC4\x9FYIZ\x98~\xCE\x0F\xB3\x0F\xFE=\xA9\xE8\xA4\x19\xB2\x17yi9\xD9\x15\xDA\xAC%\x83\xDA\xDE|F\x16\xF8w\xC2\xEA\x13\xC3M\r\x99\x81\xA6u\xAA\vt\x04\x03M\x15o]\x8BYO\xDDlXL\x15\x14F*O\x0E\xC0\xAE\xF7p\xEE\xA4b\xDA3#\xB2\xA0\xF6\xE5\xF9\x8E\x03{9{\xC1\xFD\x9E\xDDRp\xE4\xEE\r\xFB\xE8#\x1C\xCA\x02\xCB&$\x9E\x87d\x1AN\xE6\xDBx\x96\x908!O\x9Fc\x14+p\xE2\xE6\xE2{\xAF\x9E&d\xE6\xD5\x83\xA2\x1FFuh\xBED\xC1\xEB\xCC\x8E8\x1FP\xD4\x8A\xD2Og\xE0\x9D\xBA\x04\x01\xCAu\x1DX \x8A\xC6\xBE\xB4\x8D\e2rx\xFC\x85(\xC0\xAE\xD1\x1F\x7F,\xFB\x06PK\x03\x04\x14\x00\x00\x00\b\x00bpyF\xA2\xD6\x12\xDD\xC4\x05\x00\x00\xBF\x05\x00\x00\x11\x00\x00\x00doc_thumbnail.png\x01\xBF\x05@\xFA\x89PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00@\x00\x00\x00@\b\x02\x00\x00\x00%\v\xE6\x89\x00\x00\x00\tpHYs\x00\x00\x0E\xC4\x00\x00\x0E\xC4\x01\x95+\x0E\e\x00\x00\x05qIDATh\x81\xEDZ]o\xDBT\x18~\x8Ec;\x8D\x9D\xA6i\x12\xD2dd\xA3\x1Dl\x02\x89V\xDB\x90`\x17LB\x02\xC4\x05\xD7\xDCp\xC5=\xFFa\xBF\x80_\x82&\x18\x1A0\xC1\xCA\xDAQ\x84\x06c\x88\r\xC6\x06\xEA*\xAD\xD3\xDA\x84~\xACI\x97\xB8\xF1\xC7y\xB9p\x9A8\x8E\x9B\xC4N\xD2dR\x1F)\x8Es>\xDE\xF3>'\xEF\xC79\xC7fD\x84\xE7\x19\xE2\xB0\x15\xE8\x15G\x04\x86\x8D#\x02=\x80\x13\x000\x10c,\xB0\x90\x81\x10\xA8kV/\xD9\xA9`\xA7L\x11q\xCF2\xB4[\x0FI\x0E\xE99\xE5\xF1\xE2\xDF\x1C\xC0\xDC\xD4\xFA\xF9\xF3\x1F\x8C\x8D\xA9\xC1\xC6\xEA\e\x81\xADbe\xE9^\xC5\xA9\xD9\xCB\xD1\x95\xB5\xA7dX\x88I\xA5\x10\xB3\x9C\x8D5\xA0\b\xBC\x00\xA8\xAA\"\xCBI\xCEy\xE0q\xFB@\x80\x88\xEE\xFD\xFB\xF0\x8F\xDB\xDF\x85\x18\xAFk\x06\xA0TB4\x04\x84\x0E\xEC\x98LNF\xA3*\x80mMQ\x94\x80\xA3\xF7J\xA0j\xF0\xC5\xA5\x1F\xB6\v\x0FB~\xCC\x981\x96LN\xAAjMk\x93\v\x81\x15\bN\x80\x80\xD5\xC2\xB3\xF9\xF9K\x8A\xB0\xEB\xAB#c\xEC\xD8\xB1)Q\xEC\x8F\xF5\x06\x94\xC2\x89\x16o-\xAF-\x7F\xAF\b\xFE\xCCW\x92\xC4L&-\bMS\xFEb\xE2p\xA3\x90i\x9A\x9F\x7Fs\x8DU\x96}\x99\r\x00I\x12\xB3\xD9\xA9\xD6\xA0)\x1D\xEC'\x1D\xE1\x8F\x00\x11\xFE\\\xD9\xBAu\xF3\x8A_\xB3\x01\xA0\xAAJ*\x95\xF0\xDB\xAB#|\x10\xE0D\x97\x17\xEEU\xF27\xFC\x9A\r\x80x<61\x11\xF3\xDB\xAB\etK\xA0X6._\xFDV6V\xFD\x9A\r\x80T*Q\x0F8}Gg\x02\xB6\xD9\xDC\xF9\xF5\v\x19{~\xA5\xF77\xE0x\xA2\x83\xE8\xAAAWn\xDC56~\f\xA0\x82$\x89\xE9tj\xA0\xDA\xA3=\x81\xB5m\xFD\xDA\xF5\xAB\xB2\xB1\x1A@\xEEA\x01\xA7\xEF\xF0&@\x84\xDF\xFFY_\xBE\xF3\xA5\xCC-\xCF\x06\xED\xA1\xAAJ29y\b\xDA\xC3\x93@\xD5\xE0__\xBF\xA9o\xDF\x0E&1\x1AU\x93\xC9\xC9\xDE\xB4\xF2\x017\x81\xF5m\xFD\xDA\xFC%\xC9\xDA\n&n\xA0\x01\xC7\x13M\x04\xF2\x9B\x9B?/}\x15\x15M\x882\x11\xE9\xBA\xD1\xBD \xC6X&\x93\x96e\xA9\xDF\x1Av@\x13\x012\x9E\x9E\x9C\xCE\xB662\f\x83\xF3\xDA\xEEdw\xB7l\xDF\xE8\xBA^\xAD\xEA\xFB\xF7F/\xE1\xD2\xB2\xAA\x00\x88\x88P\xFB\x10'9\xDC\xF8'mg\xF2t\xAA\xAE\x86\x94\xA4\xC6\xBC\x86\xC3rk\x03\xC30M\xB3+ww\x9DB\x15\xB6\xF5\xFCn\xE4\xE3\x8B\x9F\xB5\xB6\x9C\x88\x8A\xE3J\x88s\"\xE2gN'C\xCCz\xFD\xF4\x89L\"\xFC\xE1\xFB\x17\x9C\xFA4\x11\xB8_\x88\x0F\xC2\xFBL.,\xFC\x05\xAD\xCA\x01\xFC\xF4\xCB\n\x80R\xD9,U\x1C\x84\xBD\xA6\xB6X\xB6\x8Ae\v\x80\xAC\xA6\xE6\xEFZ ,>\x12@\xFA\x93\xF2\x83O?\x9A\xF5&\x90M\xC8{\x01\xBD\xB7\x1D\xB6\xF6\xA2\v\xBB\xEF2\x06& \xFC&\x98\x80\x88\x80L\bL\x00\x18\x18\xEA&\x02\x10\x88jW\xB2@\x16\xB8}\xD5\rK\xD7\xCD\xAA\xA6\x97\xD6\x80\xA6?\xB1\x89\xC0LZ\xB8?\x00\x02A@^\xBF\x88\x00>\xCE6\x9DU\xFD\xC9\xF3\xA1P\xA8K\x1F\b\x04\xDA\xF7\x1Db\x8C\x9D;3\xEB\xAC\e\xC9\x83-\xF2\xFAI\xB6aQd,\xE2\xAC\x1C\x12\x816\x8B\f\xCF\xC3r{\xFEA\x00o\xE7\x03\xA3\x0E\"jy\x1A\xD0D`\xBDt\xA8\xAB\x00\x0Ft|VA\xDC\x95J\x9A\b\xE4\x12\xC2\xCE\x93~\xEB\xD43\xA8~\xA9GY\a\x9A\bH\x033\xA8F\xB0o\x83\xF6\xD3_3\x1F\x1Ac\xBB@#\xDF\x8E\xB6\x0F\xB8\xA7\x9B\x88x.w\xC2Y4\xC2\x04\xC8q\xD7\x88\xA4\xEE\x03\x91\x11&\xD0H\xC0\x8D\x02\xEAH\xC0\xE4\x82\xE8\xFF\xD8'0\xBA\xDCt\xDA\xCEk\xAF\xB3]Un\x02\e\xCF\xC6\xB2\xB1J\x1FT\xEB;\x88\b\x84\x96=\xBA\x9B\xC0LZ\xD8\xF3}\xFC\xE3\x13\x81\xF7\xFAD\x8CLW\xD9\xE1\xFA@p\xD5k_\xAA\xE4\x9E\xDD\x91qbvp\x1E\xA8\x97\x13\xA5\xD3S\xAE\xCA\x91!\xD0\x0E\x8Eh\xF4|\x85Q\ajki\xEA\xE8\xC4\x9A\x11\xE0\xF8y\xF0\xA8\xA52\"jK\x80\x13[-N\xBE\x14-\x0EP\x15\xBF\xD3\xD3\x94\x8F\t\xED\t\b\fo\xBD\"\xE5\xF3\x01u\xEB\t-\xBB0\xAA\x17:8\x84\xB1\xE3\xEA7\xC2>@\xF5o;\r\x83\x88\x12\xCAp\xF3@p\xD8\xEBR\x9A\x9B;\xEB\xAAp\x13P\x94\x98(\x86M\xB3\xEAK\xFC\xE0N\xD2\x9B\xD6s\xDD\xACF'&\xA6fg\xA74\xAD\x94\xCF?,\x95\xFE\xE3\xDD=\x1F8\x8C'\x01D\x8C\xD1\xB9iw\xB1\xB7\tE\"\xB1\x99\x99\xB3D\xBCX,\x14\n+\x95J\xA9\x8B\xED\xEA\xC0`\xBF\xFB\xC2\xE8\x9D\xB9\xD8\xF9s\xC7]\x95\xED|\x801!\x1E\xCF\xC6\xE3Y\xD3\xD477\x1Fml\xAC\xFA5-[LT\x89\x84E\xE8\x14p)$0\x9C:&|r!\xF6\xF6\xABI\x0F\xE9\xBE\xDEZlcZ\x9A\xE6\xE2\xC6\x04A\xC8dNf23\xF6\xBB@;\x15\xDCy\x82\xFBy\xFC\xF6\x18\xA5*\x8AU0\x01\x8C5g\x86\xFD]\xBB\xC4\x90\x89\xE2\x8D\x1CR*\xDE{\r\xF1\x83OK\xFC\x11\xA8\x8D\xE2eZ\x0E\x02l|<1==;>\xDE\xE1\xA8\xBB\xA8\xA1X_\\\xEE/\xE6\xB21\x7Fo\x1E\x04!P\x87\xD3\xB44M\x97\xA4p.w*\x95:.I\xE1\xC02\xFD\xA2'\x02uhZ\x89\xB1P\xE0\xD7\xC6zA\x7F\b\f\x11\xCFK&>\x10G\x04\x86\x8D#\x02\xC3\xC6\xFF\x88\x9Fh\xDD3,\x1E\xD7\x00\x00\x00\x00IEND\xAEB`\x82PK\x03\x04\x14\x00\x00\x00\b\x00bpyFv]\xB2\x96\xA6\x00\x00\x00n\x01\x00\x00\x0E\x00\x00\x00references.xml\xA5\xCF?\x0F\x820\x10\x87\xE1\xAF\xD2\xDCN\v\xBA\x18\xC2\x9F\xCD\t'5qm\xCA\t\x8D\xD0#\xBD*||\x11\x12\x9D\x89\xFB=\xEF\xE5\x97\x95S\xDF\x89\x17z\xB6\xE4rHd\f\x02\x9D\xA1\xDA\xBA&\x87\xEB\xE5\x18\x1D@p\xD0\xAE\xD6\x1D9\xCC\xC1\x11\x88\xB2\xC8<\xDE\xD1\xCF\x87\xC8b\x0E8\xCE\xA1\raH\x95\xE2\a\x06\xD3>\a\xD9\x105\x1DJC\xBDb\xD3b\xAFY\xCDu\xF5\x83\xB0\xCA\xD4\xFFa'\xB6_=\x8E\xA3\x1C\xF7\x92|\xA3vq\x9C\xA8\xDB\xA9:/8\xB2\xEE\xB3\xC0\xE0\xAC\xD8\xA6k\xB1\"\xA3\xC3\xB2y\xF3s\xB1Y\xC8\x89k\x10\xAAx\x03PK\x01\x02\x00\x00\x14\x00\x00\x00\b\x00bpyF\xB6bu{d\x02\x00\x00\xF4\x0E\x00\x00\f\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00document.xmlPK\x01\x02\x00\x00\x14\x00\x00\x00\b\x00bpyFj\xF8\xE8\xE7w\x01\x00\x00\xAF\x03\x00\x00\x16\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x00\x8E\x02\x00\x00documentProperties.xmlPK\x01\x02\x00\x00\x14\x00\x00\x00\b\x00bpyF\xA2\xD6\x12\xDD\xC4\x05\x00\x00\xBF\x05\x00\x00\x11\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x009\x04\x00\x00doc_thumbnail.pngPK\x01\x02\x00\x00\x14\x00\x00\x00\b\x00bpyFv]\xB2\x96\xA6\x00\x00\x00n\x01\x00\x00\x0E\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x00,\n\x00\x00references.xmlPK\x05\x06\x00\x00\x00\x00\x04\x00\x04\x00\xF9\x00\x00\x00\xFE\n\x00\x00\x00\x00"
		###
		sfile=File.join(ENV["HOME"], "temp.style")
		fi=File.open(sfile, "wb")
		fi.write(txt)
		fi.close
		styles.add_style(sfile, true)
		File.delete(sfile)
		###
		msg<<" . "
		Sketchup.status_text=msg
		combo=File.join(tdir, "ComboTexture.png")
		keys = {
		   :filename => combo,
		   :width => wi,
		   :height => hi,
		   :antialias => false,
		   :compression => 0.9,
		   :transparent => true
		}
		view.write_image(keys)
		###
		model.abort_operation
		###
		model.start_operation(self.to_s)
			camm=Sketchup::Camera.new(eye, tar, up, per)
			view.camera=camm
			mat=mats.add("ComboTexture")
			mname=mat.display_name
			mat.texture=combo
			mat.texture.size=[mat.texture.image_width, mat.texture.image_height]
			mat.color=mat.texture.average_color
			styles.selected_style=ostyle
		model.commit_operation
		###
		msg<<" Done..."
		Sketchup.status_text=msg
		###
		Dir.entries(tdir).each{|f|
			next if f=='.' || f=='..'
			File.delete(File.join(tdir, f))
		}
		begin
			Dir.delete(tdir)
		rescue
		end
		UI.messagebox("Added Material '#{mname}'.\nIt is made from ALL of the Model's Textures.\nPlease manually delete the 'temp.style'...")
		Sketchup.send_action("selectSelectionTool:")
		return true
	end
end
end
